'---------------------------------------------------------------------------------------------
'Example for using of the easy to use low level library SFCmemio.dll in Basic  (www.SFChip.de)
'no setup, no installation, no init, only copy it in your directory (or the windows directory)
'---------------------------------------------------------------------------------------------

'------------------------------ The functions of SFCmemio.dll: -------------------------------
'PEEK4 reads  a 4-byte value from the cpu memory adress (=32-bit=4-byte adress value)
'POKE4 writes a 4-byte value (wert) into the cpu memory (adress=32-bit=4-byte adress value)
'OUTB  writes a 1-byte value (wert) at the cpu IO port (port=16-bit=2-byte IO port value)
'OUTW  writes a 2-byte value (wert) at the cpu IO port (port=16-bit=2-byte IO port value)
'OUTDW writes a 4-byte value (wert) at the cpu IO port (port=16-bit=2-byte IO port value)
'INB   reads  a 1-byte value from the cpu IO port (port=16-bit=2-byte IO port value)
'INW   reads  a 2-byte value from the cpu IO port (port=16-bit=2-byte IO port value)
'INDW  reads  a 4-byte value from the cpu IO port (port=16-bit=2-byte IO port value)
'---------------------------------------------------------------------------------------------
'examples for using SFCmemio with C-sharp (C#, *.cs files):
'        [DllImport("memio.dll")]
'        private extern static byte INB(Int32 adress);
'        [DllImport("memio.dll")]
'        private extern static Int32 OUTB(Int32 adress,byte wert);


'---------------------------------------------------------------------------------------------
#COMPILE EXE "TestSFC_LLLib.exe"
#INCLUDE "api.inc"


declare FUNCTION PEEK4 lib "SFCmemio.dll" (byval adress as dword) as long
declare FUNCTION POKE4 lib "SFCmemio.dll" (byval adress as dword, byval wert as long) as long
declare FUNCTION OUTB  lib "SFCmemio.dll" (byval adress as word, byval wert as byte)  as long
declare FUNCTION OUTW  lib "SFCmemio.dll" (byval adress as word, byval wert as word)  as long
declare FUNCTION OUTDW lib "SFCmemio.dll" (byval adress as word, byval wert as dword) as long
declare FUNCTION INB   lib "SFCmemio.dll" (byval adress as word) as byte
declare FUNCTION INW   lib "SFCmemio.dll" (byval adress as word) as word
declare FUNCTION INDW  lib "SFCmemio.dll" (byval adress as word) as dword



FUNCTION PBMAIN () AS LONG
  local buffer as asciz*10000
  
  'reading of bios-ram and show it in a message box:
  buffer = buffer + "RS232-1:                       "+hex$(peek4(&h400) and &hffff)+$CR+$LF
  buffer = buffer + "LPT-1__ :                       "+hex$(peek4(&h408) and &hffff)+$CR+$LF


  msgbox buffer,, "TestSFC_LLLib:"
END FUNCTION
